/*
 * Copyright (c) 2011 NVIDIA Corporation.  All rights reserved.
 *
 * NVIDIA Corporation and its licensors retain all intellectual property
 * and proprietary rights in and to this software, related documentation
 * and any modifications thereto.  Any use, reproduction, disclosure or
 * distribution of this software and related documentation without an express
 * license agreement from NVIDIA Corporation is strictly prohibited.
 */

#ifndef __kd_NV_stream_properties_h_
#define __kd_NV_stream_properties_h_

#include <KD/kd.h>
#if !defined(KD_NV_gui_manager) || !KD_NV_gui_manager
#error "NV_stream_properties requires NV_gui_manager"
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* Other stream properties (TODO: Need an official set of values) */
// 1 element KDint property for displayable ID
#define KD_STREAMPROPERTY_DISPLAYABLE_ID_NV 6025
// 1 element KDfloat32 property for framerate
#define KD_STREAMPROPERTY_FRAMERATE_NV 6026
#if defined(KD_NV_manageable_stream_properties) && KD_NV_manageable_stream_properties
// 3 element KDfloat32 property for color control
// This property is managable
#define KD_STREAMPROPERTY_COLOR_CONTROL_NV 6027
// 1 element KDboolean property for visibility
// This property is manageable
#define KD_STREAMPROPERTY_VISIBLE_NV 6028
#endif

#ifdef __cplusplus
}
#endif

#endif /* __kd_NV_stream_properties_h_ */
