#ifndef ARRAY_INCLUDED
#define ARRAY_INCLUDED


typedef struct {
    int elem_count;
    int elem_size;
    int buff_size;
    void *buffer;
} Array;


// initialization and clean-up.
Array *Array_new(int elemsize);
void Array_delete(Array *o);
void Array_init(Array *o, int elemsize);
void Array_destroy(Array *o);
void Array_clear(Array *o);
    // new and delete malloc and free the Array struct, where
    // init and destroy don't.

// Access functions.
void Array_push(Array *o, void *elem);
void *Array_get(Array *o, int i);
void Array_pop(Array *o);
    // we can random read the array, but we can add or delete only
    // the last item.


#endif /* ARRAY_INCLUDED */
