#ifndef SLIDER_INCLUDED
#define SLIDER_INCLUDED

#include <GLES2/gl2.h>

typedef struct {

  GLboolean visible;

  GLboolean focus;
  float left, right, bottom, top;
  float minimum, maximum, value;
  float knob_pos;
  GLboolean mouse_down;

  float3 rod_color;
  float2 rod_vertices[12];
  float3 rod_colors[12];

  float3 knob_color;

  float3 knob_colors[5];
  float2 knob_vertices[8];
} Slider;


Slider *Slider_new(float minimum, float maximum, float init);
void Slider_delete(Slider *o);

void Slider_setCB(Slider *o, void (*CB)(float));
void Slider_setPos(Slider *o, float left, float right, float bottom, float top);

void Slider_draw(Slider *o);

GLboolean Slider_setValue(Slider *o, float val);
float Slider_getValue(Slider *o);
void Slider_select(Slider *o, GLboolean sel);


#endif // SLIDER_INCLUDED
