#ifndef VBO_INCLUDED
#define VBO_INCLUDED

#include <GLES2/gl2.h>
#include <GLES2/gl2ext.h>

GLboolean    VBO_init  (void);
void         VBO_deinit(void);
unsigned int VBO_alloc (int size);
GLboolean    VBO_setup (int size);
extern int   vbo_initialized;
extern int   use_VBO;

//#define DUMP_VERTS_PER_SEC

#ifdef DUMP_VERTS_PER_SEC
extern int   vertCount;

#define glDrawArrays(mode, start, count)                     \
                    vertCount += (count);                    \
                    glDrawArrays(mode, start, count)

#define glDrawElements(mode, count, type, indices)           \
                    vertCount += (count);                    \
                    glDrawElements(mode, count, type, indices)
#endif

#define VBO_ALIGNMENT 4
#define VBO_align(size) ((size + VBO_ALIGNMENT - 1) & ~(VBO_ALIGNMENT - 1))
#define VBO_NAME 1

// function pointer typedefs
typedef void (*PFNGLBINDBUFFER)(GLenum target, GLuint buffer);
typedef void (*PFNGLBUFFERDATA)(GLenum target, GLsizeiptr size,
                                const GLvoid *data, GLenum usage);
typedef void (*PFNGLBUFFERSUBDATA)(GLenum target, GLintptr offset,
                                   GLsizeiptr size, const GLvoid *data);
typedef void (*PFNGLDELETEBUFFERS)(GLsizei n, const GLuint *buffers);

#endif // VBO_INCLUDED
