
typedef struct {
    unsigned short c;       /* Potentially support 16-bit glyphs. */
    unsigned char width;
    unsigned char height;
    signed char xoffset;
    signed char yoffset;
    signed char advance;
    char dummy;           /* Space holder for alignment reasons. */
    short x;
    short y;
} NVTexfont2GlyphInfo;

struct _NVTexfont2RasterFont {
    GLuint texobj;
    int tex_width;
    int tex_height;
    int max_ascent;
    int max_descent;
    int num_glyphs;
    int min_glyph;
    int range;
    unsigned char *teximage;
    NVTexfont2GlyphInfo *tgi;
    int *lut;
    GLfloat *st;
    GLshort *vert;
};

struct _NVTexfont2VectorFont {
    unsigned char *vertices;
    int *offsets;
	int *counts;
	unsigned char *widths;
    int vertNo;

	GLboolean antialias;
    GLuint vbo;
};

typedef struct {
    float r,g,b;
    float scale;
    float x,y;
} nvtexfont2State;


/* byte swap a 32-bit value */
#define SWAPL(x, n) { \
                 n = ((char *) (x))[0];\
                 ((char *) (x))[0] = ((char *) (x))[3];\
                 ((char *) (x))[3] = n;\
                 n = ((char *) (x))[1];\
                 ((char *) (x))[1] = ((char *) (x))[2];\
                 ((char *) (x))[2] = n; }

/* byte swap a short */
#define SWAPS(x, n) { \
                 n = ((char *) (x))[0];\
                 ((char *) (x))[0] = ((char *) (x))[1];\
                 ((char *) (x))[1] = n; }


#define VERT_ARRAY 0
#define TEX_ARRAY 1

#define FONT_HEIGHT_RATIO (1.0f/33.0f)

extern void initShaders(void);
extern void deinitShaders(void);

extern GLuint rasterProg, vectorProg;
extern char *lastError;
